<template>
        <div class="app-layoutpanel Usr1119718635" v-loading="isLayoutLoadding" :style="{width: '100%', height: '100%',  overflow: 'auto'}">
        <div v-show="!isLayoutLoadding" :style="{height: '100%', width: '100%'}">
    <app-standard-container name="page_container" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #container1>
    <app-standard-container name="container1" :isMultiContainer="false" :layoutModelDetails="layoutModelDetails">
        <template #static_text1>
        <app-preset-text name="static_text1" :layoutModelDetails="layoutModelDetails"/>
        </template>
        <template #static_text2>
        <app-preset-text name="static_text2" :layoutModelDetails="layoutModelDetails"/>
        </template>
    </app-standard-container>
        </template>
    </app-standard-container>
        </div>
    </div>

</template>
// 基于 @CONTROL/面板/CONTROL-BASE.vue.ftl 生成
<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model,Inject } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util,ViewTool } from '@/utils';
import NavDataService from '@/service/app/navdata-service';
import AppCenterService from "@service/app/app-center-service";
import IBIZCustomerEntityService from '@/service/ibizcustomer/ibizcustomer-service';
import Usr1119718635Service from './usr1119718635-panel-service';
import IBIZCustomerUIService from '@/uiservice/ibizcustomer/ibizcustomer-ui-service';
import { PanelDetailModel,PanelRawitemModel,PanelTabPanelModel,PanelTabPageModel,PanelFieldModel,PanelContainerModel,PanelControlModel,PanelUserControlModel,PanelButtonModel } from '@/model/panel-detail';
import Usr1119718635Model from './usr1119718635-panel-model';
import CodeListService from "@/codelist/codelist-service";
import UIService from '@/uiservice/ui-service';


@Component({
    components: {
      
    }
})
export default class Usr1119718635Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Usr1119718635Base
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Usr1119718635Base
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public context!: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public viewparams!: any;

    /**
     * 视图操作参数(父级)
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public pViewCtx!: any;

    /**
     * 视图操作参数
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    public viewCtx: any = {};

    /**
     * 监听视图操作参数变化
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Watch('pViewCtx', { immediate: true })
    public onViewCtxChange(newVal: any, oldVal: any) {
        Object.assign(this.viewCtx, newVal, { xData: this, ctrl: this });
    }

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Usr1119718635Base
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Usr1119718635Base
     */
    public getControlType(): string {
        return 'PANEL'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Usr1119718635Base
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Usr1119718635Service}
     * @memberof Usr1119718635Base
     */
    public service: Usr1119718635Service = new Usr1119718635Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {IBIZCustomerService}
     * @memberof Usr1119718635Base
     */
    public appEntityService: IBIZCustomerEntityService = new IBIZCustomerEntityService({ $store: this.$store });
    


    /**
     * 转化数据
     *
     * @param {any} args
     * @memberof  Usr1119718635Base
     */
    public transformData(args: any) {
        let _this: any = this;
        if(_this.service && _this.service.handleRequestData instanceof Function && _this.service.handleRequestData('transform',_this.context,args)){
            return _this.service.handleRequestData('transform',_this.context,args)['data'];
        }
    }

    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Usr1119718635Base
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Usr1119718635Base
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }
    /**
     *  处理部件事件
     *
     * @memberof Usr1119718635Base
     */
    public async handleCtrlEvents(eventName: string, args: any = {}): Promise<boolean> {
        const actionData = {
            data: this.getData() || {},
            context: Util.deepCopy(this.context),
            viewparams: Util.deepCopy(this.viewparams),
            xData: this
        }
        let result: boolean = true;
        Object.assign(actionData, args);
        if (!result) {
            return false;
        }
        this.$emit(eventName, actionData);
        return true;
    }



    /**
     * 接口实现
     *
     * @returns {any[]}
     * @memberof Usr1119718635Base
     */
    getDatas(): any[] {
        if (!this.layoutData) {
            return [];
        }
        return [this.layoutData];
    }

    /**
     * 接口实现
     *
     * @returns {*}
     * @memberof Usr1119718635Base
     */
    getData() {
        return this.layoutData;
    }

    /**
     * 父级部件引用
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public parentRef?: any;

    /**
     * 面板数据对象
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public inputData?: any;

    /**
     * 操作栏模型数据
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    @Prop() public actionModel?: any;

    /**
     * UI数据对象
     *
     * @type {*}
     * @memberof Usr1119718635Base
     */
    public data:any = {};

    /**
     * 数据模型对象
     *
     * @type {Usr1119718635Model}
     * @memberof Usr1119718635Base
     */
    public dataModel:Usr1119718635Model = new Usr1119718635Model();

    /**
     * 代码表服务对象
     *
     * @type {CodeListService}
     * @memberof Usr1119718635Base
     */
    public codeListService:CodeListService = new CodeListService();

    /**
     * 界面UI服务对象
     *
     * @type {IBIZCustomerUIService}
     * @memberof Usr1119718635Base
     */  
    public appUIService:IBIZCustomerUIService = new IBIZCustomerUIService();

    /**
     * 视图布局顶级成员名称
     *
     * @public
     * @memberof List_itempanelBase
     */
    public rootLayoutDetailNames: string[] = [ 'page_container' ];

    /**
     * 视图布局面板项模型对象
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutItems:any = {
        static_text1:{ name: 'static_text1', type: 'ITEMLAYOUT', caption: '文本', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , viewType: 'DELISTVIEW', predefinedType: 'STATIC_TEXT', contentType: 'RAW', contentStyle: '', rawContent: '主文本', htmlContent: '', renderMode: 'TEXT', wrapMode:'', vAlign:'', hAlign:'', },
        static_text2:{ name: 'static_text2', type: 'ITEMLAYOUT', caption: '文本', isShowCaption: true, sysCss: '', itemType: 'RAWITEM', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'container1', panel: this , viewType: 'DELISTVIEW', predefinedType: 'STATIC_TEXT', contentType: 'RAW', contentStyle: '', rawContent: '文本内容', htmlContent: '', renderMode: 'TEXT', wrapMode:'', vAlign:'', hAlign:'', },
        container1:{ name: 'container1', type: 'ITEMLAYOUT', caption: '容器', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:-1, flexParams:{align:'',dir:'',vAlign:''}, parentName: 'page_container', panel: this , details:['static_text1','static_text2'] , dataRegionType: 'INHERIT' },
        page_container:{ name: 'page_container', type: 'ITEMLAYOUT', caption: '', titleBarCloseMode: 0, isShowCaption: false, sysCss: '', itemType: 'CONTAINER', itemStyle: 'DEFAULT', visible: true, disabled: false, layout:'FLEX', layoutPos:'', layoutHeight:0, heightMode:'', layoutWidth:0, widthMode:'', spacingBottom:'', spacingLeft:'', spacingRight:'', spacingTop:'', hAlignSelf:'', vAlignSelf:'', flexGrow:0, flexParams:{align:'',dir:'column',vAlign:''}, panel: this , details:['container1'] , dataRegionType: 'INHERIT' }
    }

    /**
     * 布局面板是否加载
     *
     * @public
     * @memberof List_itempanelBase
     */
    public isLayoutLoadding: boolean = true;

    /**
     * 布局面板数据
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutData:any = {};

    /**
     * 布局面板模型对象
     *
     * @public
     * @memberof List_itempanelBase
     */
    public layoutModelDetails:any = {};

    /**
     *  初始化布局
     *
     *  @public
     *  @memberof List_itempanelBase
     */
    public async initLayout() {
        if (this.rootLayoutDetailNames.length > 0) {
            for (let i = 0; i < this.rootLayoutDetailNames.length; i++) {
                const name = this.rootLayoutDetailNames[i];
                const rootItem = this.layoutItems[name];
                if (!rootItem) {
                    return;
                }
                await this.initLayoutItem(rootItem);
            }
        }
        return true;
    }

    /**
     *  初始化布局项
     *
     *  @public
     *  @memberof List_itempanelBase
     */
    public async initLayoutItem(layoutModelItem: any, index?: number) {
        const { name } = layoutModelItem;
        const layoutModelDetail = Util.getLayoutItemInstance(layoutModelItem);
        if (!(index || index === 0)) {
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, name, layoutModelDetail);
            this.$set(this.layoutData, name, layoutModelDetail.getData());
        } else {
            layoutModelDetail.setIndex(index);
            await layoutModelDetail.load(this.context, this.viewparams);
            this.$set(this.layoutModelDetails, `${name}_${index}`, layoutModelDetail);
            this.$set(this.layoutData, `${name}_${index}`, layoutModelDetail.getData());
        }
        if (layoutModelDetail && layoutModelDetail.details) {
            if (layoutModelDetail.dataRegionType === 'MULTIDATA') {
                const multiData = layoutModelDetail.getData();
                if (multiData && multiData.length > 0) {
                    for (let i = 0; i < multiData.length; i++) {
                        for (let j = 0; j < layoutModelDetail.details.length; j++) {
                            const key = layoutModelDetail.details[j];
                            if (this.layoutItems[key]) {
                                await this.initLayoutItem(this.layoutItems[key], i);
                            }
                        }
                    }
                }
            } else {
                for (let i = 0; i < layoutModelDetail.details.length; i++) {
                    const key = layoutModelDetail.details[i];
                    if (this.layoutItems[key]) {
                        await this.initLayoutItem(this.layoutItems[key], index);
                    }
                }
            }
        }
    }

    /**
     * 计算面板按钮权限状态
     *
     * @public
     * @memberof List_itempanelBase
     */
    public async computeButtonAuthState() {
        for (const key in this.layoutModelDetails) {
            const layoutModel = this.layoutModelDetails[key];
            if (layoutModel.itemType == 'BUTTON') {
                await layoutModel.computeActionAuthState();
            }
        }
    }


    /**
     * 监听数据对象
     *
     * @memberof Usr1119718635Base
     */
    @Watch('inputData', { deep: true, immediate: true } )
    public onInputDataChange(newVal: any, oldVal: any){
        if(newVal){
            this.computedUIData(newVal);
        }
    }

    /**
     * 生命周期
     *
     * @memberof Usr1119718635Base
     */
    public mounted () {
        this.afterMounted();
    }

    /**
     * 执行mounted后的逻辑
     *
     * @memberof Usr1119718635Base
     */
    public afterMounted () {
        const _this: any = this;
        _this.initLayout().then((result: any) => {
            _this.isLayoutLoadding = false;
        });
    }

    /**
     * 计算UI展示数据
     * 
     * @param codelistArray 代码表模型数组
     * @memberof Usr1119718635Base
     */
    public computedUIData(newVal:any){
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            this.dataModel.getDataItems().forEach((item:any) =>{
                this.data[item.prop] = newVal[item.prop];
            })
        }
    }

    /**
     * 打开编辑数据视图
     *
     * @type {any}
     * @memberof Usr1119718635Base
     */
    public opendata(args: any[],fullargs?:any[],params?: any, $event?: any, xData?: any){
        if (this.parentRef.opendata && this.parentRef.opendata instanceof Function) {
            this.parentRef.opendata(args,fullargs,params, $event, xData);
        }
    }

    /**
     * 打开新建数据视图
     *
     * @type {any}
     * @memberof Usr1119718635Base
     */
    public newdata(args: any[],fullargs?:any[], params?: any, $event?: any, xData?: any) {
        if (this.parentRef.newdata && this.parentRef.newdata instanceof Function) {
            this.parentRef.newdata(args,fullargs,params, $event, xData);
        }
    }
    
    /**
     * 删除
     *
     * @param {any[]} datas
     * @returns {Promise<any>}
     * @memberof Usr1119718635Base
     */
    public async remove(datas: any[]): Promise<any> {
        if (this.parentRef.remove && this.parentRef.remove instanceof Function) {
            return this.parentRef.remove(datas);
        }
    }

    /**
     * 刷新
     *
     * @param {*} [args={}]
     * @memberof Usr1119718635Base
     */
    public refresh(args: any = {}) {
        if (this.parentRef.refresh && this.parentRef.refresh instanceof Function) {
            this.parentRef.refresh(args);
        }
    }

    /**
     * 处理值改变
     *
     * @public
     * @params args 改变数据
     * @params index 多数据容器下标
     * @memberof List_itempanelBase
     */
    public handleValueChange(args: { name: string, value: any }, index?: number) {
        const { name, value } = args;
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        if (!fullName || !this.layoutData.hasOwnProperty(fullName)) {
            return;
        }
        this.layoutData[fullName] = value;
        this.layoutModelDetails[fullName].setData(value);
        this.panelLogic(name, index);
        this.panelEditItemChange(name, value);
        this.computeButtonAuthState();
    }

    /**
     * 面板编辑项值变化后续操作
     *
     * @public
     * @param property 编辑项名
     * @param value 编辑项值
     * @returns {void}
     * @memberof Usr1119718635Base
     */
    public panelEditItemChange(property: string, value: any){
        // 面板数据变化事件
        if((this.dataModel.getDataItems instanceof Function) && this.dataModel.getDataItems().length >0){
            let modelitem =this.dataModel.getDataItems().find((item:any) =>{
                return item.name === property;
            }) 
            if(modelitem){
                this.$emit('panelDataChange',{[modelitem.prop]: value});
            }
        }
    }


    /**
     * 面板逻辑
     *
     * @public
     * @params name 改变项名称
     * @params index 多数据容器下标
     * @memberof Usr1119718635Base
     */
    public panelLogic(name: string, index?: number): void {
    }

    /**
     * 处理按钮点击
     *
     * @public
     * @params name 按钮项名称
     * @params index 多数据容器下标
     * @memberof List_itempanelBase
     */
    public handleButtonClick(name: string, index?: number) {
        let datas: any[] = [];
        let fullName = (index || index === 0) ? `${name}_${index}` : name;
        const data: any = this.layoutModelDetails[fullName].getData();
        if (data) {
            if (data instanceof Array) {
                datas = [...data];
            } else {
                datas = [data];
            }
        }
        const xData: any = this.layoutModelDetails[fullName].getDataArea();
        const paramJO: any = {};
        const contextJO: any = {};
        const _this: any = this;
    }


}
</script>

<style lang='less'>
@import './usr1119718635-panel.less';
</style>

